/*
 * Copyright (C) 2011 Canonical Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 3, as published
 * by the Free Software Foundation.

 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranties of
 * MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by Neil Jagdish Patel <njpatel@gmail.com>
 */

public abstract class TabBarItem : Gtk.Button
{
  public string stream  { get; construct set; }
  public string tooltip { get; construct set; }
  public string icon_name { get; construct set; }

  public bool active {
    get { return _active; }
    set
    {
      _active = value;
      queue_draw ();
    }
  } 

  private Gtk.Image _image;
  private bool _active = false;

  public TabBarItem (string stream, string icon_name, string tooltip = "")
  {
    Object (stream:stream, tooltip:tooltip, icon_name:icon_name);
  }

  construct
  {
    set_size_request (40, 32);

    _image = new Gtk.Image.from_icon_name (icon_name, Gtk.IconSize.BUTTON);
    add (_image);
  }

  public override bool draw (Cairo.Context cr)
  {
    propagate_draw (_image, cr);
    return true;
  }

  // Should be implemented by sub-classes
  public abstract Gtk.Widget? get_toolbar ();
}
